<?php
/**
 * A Magento 2 module named FiloBlu/Cegid
 * Copyright (C) 2019  2019
 * 
 * This file is part of FiloBlu/Cegid.
 * 
 * FiloBlu/Cegid is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace FiloBlu\Cegid\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface CegidRepositoryInterface
{

    /**
     * Save Cegid
     * @param \FiloBlu\Cegid\Api\Data\CegidInterface $cegid
     * @return \FiloBlu\Cegid\Api\Data\CegidInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \FiloBlu\Cegid\Api\Data\CegidInterface $cegid
    );

    /**
     * Retrieve Cegid
     * @param string $cegidId
     * @return \FiloBlu\Cegid\Api\Data\CegidInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getById($cegidId);

    /**
     * Retrieve Cegid matching the specified criteria.
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \FiloBlu\Cegid\Api\Data\CegidSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Delete Cegid
     * @param \FiloBlu\Cegid\Api\Data\CegidInterface $cegid
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \FiloBlu\Cegid\Api\Data\CegidInterface $cegid
    );

    /**
     * Delete Cegid by ID
     * @param string $cegidId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($cegidId);
}
